=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: kmix
 Section: kde
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
            Norbert Preining <norbert@preining.info>,
 Build-Depends: cmake (>= 3.16~),
@@ -28,17 +29,17 @@
                pkg-config,
                pkg-kde-tools (>= 0.15.16),
                qtbase5-dev (>= 5.15.2~),
-Standards-Version: 4.6.2
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://apps.kde.org/en/kmix
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kmix
-Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kmix.git
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kmix
+Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kmix
 
 Package: kmix
 Section: sound
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends},
-Provides: x-audio-mixer,
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Provides: x-audio-mixer
 Description: volume control and mixer
  KMix is an audio device mixer, used to adjust volume, select recording inputs,
  and set other hardware options.
