## kmix 24.12.0

=== debian/changelog ===
kmix (4:24.12.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (24.12.0).
  * Update build-deps and deps with the info from cmake.
  * Bump Standards-Version to 4.7.0, no change required.
  * Refresh patches.
  * Switch to declarative KF6 debhelper build sequence.
  * Switch away from transitional pkg-config build dependency.
  * Refresh lintian overrides.
  * Refresh copyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 23 Dec 2024 23:52:30 +0100
