## kmix 24.12.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,24 +1,21 @@
 cmake_minimum_required(VERSION 3.16)
 
 # KDE Applications version, managed by release script.
-set(RELEASE_SERVICE_VERSION_MAJOR "23")
-set(RELEASE_SERVICE_VERSION_MINOR "08")
-set(RELEASE_SERVICE_VERSION_MICRO "5")
+set(RELEASE_SERVICE_VERSION_MAJOR "24")
+set(RELEASE_SERVICE_VERSION_MINOR "12")
+set(RELEASE_SERVICE_VERSION_MICRO "3")
 set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 set(KMIX_VERSION ${RELEASE_SERVICE_VERSION})
 project(kmix VERSION ${KMIX_VERSION})
-# SOVERSION of the kmixcore library
-set(KMIX_VERSION_MAJOR 5)
-# Version of the configuration, originally from core/version.h
-set(KMIX_CONFIG_VERSION 3)
 
 ####################################################################################################
 ########### options ################################################################################
 ####################################################################################################
 
-# Plasma dataengines are apparently deprecated and will be removed in Plasma 6
-option(BUILD_DATAENGINE "Build the Plasma dataengine" OFF)
+# Plasma dataengines are deprecated, needs at least porting to Plasma5Support as an intermediate
+# step, or should be removed
+#option(BUILD_DATAENGINE "Build the Plasma dataengine" OFF)
 
 # For testing OSS4 build on Linux with 4Front OSS4 installed
 #
@@ -30,11 +27,18 @@
 ########### dependencies and tests #################################################################
 ####################################################################################################
 
-set(QT_MIN_VERSION "5.15.2")
-set(KF5_MIN_VERSION "5.101.0")
+set(QT_MIN_VERSION "6.3.0")
+set(KF_MIN_VERSION "6.1.0")
+
+# SOVERSION of the kmixcore library
+set(KMIX_VERSION_MAJOR 6)
+# Version of the configuration, originally from core/version.h
+set(KMIX_CONFIG_VERSION 3)
+
 set(PA_MIN_VERSION "0.9.16")
 set(KDE_COMPILERSETTINGS_LEVEL "5.82")
-find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
+
+find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} )
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -49,7 +53,7 @@
 include(CheckSourceRuns)
 include(CheckStructHasMember)
 
-find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS
+find_package(Qt6 ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS
     Core
     DBus
     Gui
@@ -57,10 +61,11 @@
     Xml
 )
 
-find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS
-    Completion
+find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS
     Config
     ConfigWidgets
+    Crash
+    CoreAddons
     Crash
     DBusAddons
     DocTools
@@ -68,15 +73,19 @@
     I18n
     Notifications
     Solid
+    StatusNotifierItem
     WidgetsAddons
     WindowSystem
     XmlGui
 )
 
-if (BUILD_DATAENGINE)
-  find_package(KF5Plasma ${KF5_MIN_VERSION} REQUIRED)
-  set_package_properties(KF5Plasma PROPERTIES PURPOSE "Required to build the Plasma dataengine")
-endif ()
+
+# Needs at least porting to Plasma5Support as an intermediate step, or should be removed
+#if (BUILD_DATAENGINE)
+#  find_package(Plasma5Support 6.0 REQUIRED)
+#  set_package_properties(Plasma5Support PROPERTIES PURPOSE "Required to build the Plasma dataengine")
+#endif ()
+
 
 ####################################################################################################
 ########### sound backend support ##################################################################
@@ -112,21 +121,21 @@
     add_definitions(-DHAVE_SYS_SOUNDCARD_H)
   endif ()
 
-  # Running a program is hopefully more reliable than trying to
-  # grep through header files to find a definition.  Need try_run()
-  # here so as to be able to read the output result.
-  try_run(TEST_RUN_RESULT TEST_COMPILE_RESULT
+  # Comparing with preprocessor is hopefully more reliable than trying to
+  # grep through header files to find a definition.  Unlike try_run(),
+  # causes no problem for cross-compilation.
+  try_compile(OSS3_COMPILE_RESULT
           ${CMAKE_CURRENT_BINARY_DIR}
-          SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/ossversion.c
-          COMPILE_DEFINITIONS "${TEST_COMPILE_FLAGS}"
-          RUN_OUTPUT_VARIABLE TEST_RESULT_VERSION)
-  #message(STATUS "TEST_RUN_RESULT= ${TEST_RUN_RESULT}")
-  #message(STATUS "TEST_COMPILE_RESULT= ${TEST_COMPILE_RESULT}")
-  #message(STATUS "TEST_RESULT_VERSION= ${TEST_RESULT_VERSION}")
-
-  if (${TEST_COMPILE_RESULT} AND (${TEST_RUN_RESULT} EQUAL 0))
-    message(STATUS "Detected OSS version ${TEST_RESULT_VERSION}")
-    if (${TEST_RESULT_VERSION} GREATER_EQUAL 0x040000)
+          SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ossversion3.c
+          COMPILE_DEFINITIONS "${TEST_COMPILE_FLAGS}")
+  try_compile(OSS4_COMPILE_RESULT
+          ${CMAKE_CURRENT_BINARY_DIR}
+          SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ossversion4.c
+          COMPILE_DEFINITIONS "${TEST_COMPILE_FLAGS}")
+  #message(STATUS "OSS3_COMPILE_RESULT= ${OSS3_COMPILE_RESULT}")
+  #message(STATUS "OSS4_COMPILE_RESULT= ${OSS4_COMPILE_RESULT}")
+
+  if (${OSS4_COMPILE_RESULT})
       message(STATUS "Building with OSS 4 support")
       set(HAVE_OSS_4 true)
       add_definitions(-DHAVE_OSS_4)
@@ -137,20 +146,19 @@
       # to have sys/soundcard.h and not soundcard.h installed.
       check_struct_has_member(oss_mixerinfo devnode sys/soundcard.h HAVE_MIXERINFO_DEVNODE)
       if (HAVE_MIXERINFO_DEVNODE)
-	add_definitions(-DHAVE_MIXERINFO_DEVNODE)
+        add_definitions(-DHAVE_MIXERINFO_DEVNODE)
       endif ()
-    else ()
+    elseif (${OSS3_COMPILE_RESULT})
       message(STATUS "Building with OSS 3 support")
       set(HAVE_OSS_3 true)
       add_definitions(-DHAVE_OSS_3)
       set(SUPPORTED_BACKENDS ${SUPPORTED_BACKENDS} "OSS")
+    else ()
+      message(STATUS "Unable to get OSS version, assuming 3")
+      set(HAVE_OSS_3 true)
+      add_definitions(-DHAVE_OSS_3)
+      set(SUPPORTED_BACKENDS ${SUPPORTED_BACKENDS} "OSS")
     endif ()
-  else ()
-    message(STATUS "Unable to get OSS version, assuming 3")
-    set(HAVE_OSS_3 true)
-    add_definitions(-DHAVE_OSS_3)
-    set(SUPPORTED_BACKENDS ${SUPPORTED_BACKENDS} "OSS")
-  endif ()
 endif ()
 
 # PulseAudio, optional
@@ -193,6 +201,10 @@
 add_definitions(-DKMIX_VERSION=\"${KMIX_VERSION}\")
 add_definitions(-DKMIX_CONFIG_VERSION=${KMIX_CONFIG_VERSION})
 
+remove_definitions("-DQT_NO_KEYWORDS")
+remove_definitions("-DQT_NO_CAST_FROM_ASCII")
+remove_definitions("-DQT_NO_CAST_FROM_BYTEARRAY")
+
 ####################################################################################################
 ########### subdirectories #########################################################################
 ####################################################################################################
@@ -202,7 +214,7 @@
 add_subdirectory(profiles)
 
 if (BUILD_DATAENGINE)
-  if (KF5Plasma_FOUND)
+  if (Plasma5Support_FOUND)
     add_subdirectory(plasma)
   endif ()
 endif ()
@@ -298,12 +310,12 @@
   PRIVATE
     Qt::Xml
     Qt::DBus
-    KF5::I18n
-    KF5::Solid
+    KF6::I18n
+    KF6::Solid
   PUBLIC
-    KF5::ConfigCore
-    KF5::ConfigGui
-    KF5::CoreAddons
+    KF6::ConfigCore
+    KF6::ConfigGui
+    KF6::CoreAddons
 )
 
 set_target_properties(kmixcore PROPERTIES VERSION ${KMIX_VERSION} SOVERSION ${KMIX_VERSION_MAJOR})
@@ -323,6 +335,3 @@
 endif ()
 
 install(TARGETS kmixcore DESTINATION ${KDE_INSTALL_LIBDIR} LIBRARY NAMELINK_SKIP)
-install(FILES core/settings.kcfg RENAME kmixsettings.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})
-
-####################################################################################################
