## kmix 25.04.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
 cmake_minimum_required(VERSION 3.16)
 
 # KDE Applications version, managed by release script.
-set(RELEASE_SERVICE_VERSION_MAJOR "24")
-set(RELEASE_SERVICE_VERSION_MINOR "12")
-set(RELEASE_SERVICE_VERSION_MICRO "3")
+set(RELEASE_SERVICE_VERSION_MAJOR "25")
+set(RELEASE_SERVICE_VERSION_MINOR "04")
+set(RELEASE_SERVICE_VERSION_MICRO "0")
 set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 set(KMIX_VERSION ${RELEASE_SERVICE_VERSION})
@@ -91,6 +91,15 @@
 ########### sound backend support ##################################################################
 ####################################################################################################
 
+# sndio, only for that platform
+check_include_file("sndio.h" HAVE_SYS_SNDIO_H)
+if (HAVE_SYS_SNDIO_H)
+  message(STATUS "Building with sndio support")
+  set(HAVE_SNDIO_MIXER true)
+  add_definitions(-DHAVE_SNDIO_MIXER)
+  set(SUPPORTED_BACKENDS ${SUPPORTED_BACKENDS} "Sndio")
+endif ()
+
 # Sun Audio, only for that platform
 check_include_file("sys/audioio.h" HAVE_SYS_AUDIOIO_H)
 if (HAVE_SYS_AUDIOIO_H)
@@ -109,7 +118,7 @@
 
 check_include_file("soundcard.h" HAVE_SOUNDCARD_H)
 check_include_file("sys/soundcard.h" HAVE_SYS_SOUNDCARD_H)
-if (HAVE_SOUNDCARD_H OR HAVE_SYS_SOUNDCARD_H)
+if ((HAVE_SOUNDCARD_H OR HAVE_SYS_SOUNDCARD_H) AND NOT HAVE_SYS_SNDIO_H)
   add_definitions(-DHAVE_OSS_MIXER)
   set(HAVE_OSS_MIXER true)
   if (HAVE_SOUNDCARD_H)
@@ -163,6 +172,10 @@
 
 # PulseAudio, optional
 find_package(PulseAudio "${PA_MIN_VERSION}")
+set_package_properties(PulseAudio PROPERTIES
+    TYPE OPTIONAL
+    PURPOSE "Pulse audio support"
+)
 if (PulseAudio_FOUND)
   message(STATUS "Building with PulseAudio support")
   set(HAVE_PULSEAUDIO true)
@@ -263,6 +276,10 @@
 
 if (HAVE_PULSEAUDIO)
   set(kmix_backend_SRCS ${kmix_backend_SRCS} backends/mixer_pulse.cpp)
+endif ()
+
+if (HAVE_SNDIO_MIXER)
+  set(kmix_backend_SRCS ${kmix_backend_SRCS} backends/mixer_sndio.cpp)
 endif ()
 
 if (HAVE_SUN_MIXER)
@@ -319,19 +336,3 @@
 )
 
 set_target_properties(kmixcore PROPERTIES VERSION ${KMIX_VERSION} SOVERSION ${KMIX_VERSION_MAJOR})
-generate_export_header(kmixcore BASE_NAME kmixcore EXPORT_FILE_NAME kmixcore_export.h)
-
-if (HAVE_ALSA_MIXER)
-  target_link_libraries(kmixcore PRIVATE ALSA::ALSA)
-endif ()
-
-if (HAVE_PULSEAUDIO)
-  target_link_libraries(kmixcore PRIVATE PulseAudio::PulseAudio)
-endif ()
-
-if (CANBERRA_FOUND)
-  # VolumeFeedback calls Canberra directly, so public linking is required
-  target_link_libraries(kmixcore PUBLIC Canberra::Canberra)
-endif ()
-
-install(TARGETS kmixcore DESTINATION ${KDE_INSTALL_LIBDIR} LIBRARY NAMELINK_SKIP)
