=== debian/control ===
--- 
+++ 
@@ -26,12 +26,12 @@
                libkf6windowsystem-dev (>= 6.1.0~),
                libkf6xmlgui-dev (>= 6.1.0~),
                libpulse-dev (>= 0.9.16),
+               pkg-kde-tools (>= 0.15.16),
                pkgconf,
-               pkg-kde-tools (>= 0.15.16),
                qt6-base-dev (>= 6.3.0~),
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
-Homepage: https://apps.kde.org/en/kmix
+Homepage: https://apps.kde.org/kmix/
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kmix
 Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kmix.git
